<html>
<script language="Javascript">function toggleDisplay(id) { document.getElementById(id).style.display = (document.getElementById(id).style.display == "block") ? "none" : "block"; }</script>

<head>
</head>
<body>
<?
/* NDT: Network Topology Discovery
 * Spiros Ioannou 2009
 * sivann at gmail.com
 * Version 0.1 6/2009
 */

$starthost = '10.5.1.254';
$wantbrand=0;
$wantlocalarp=0;
$wantdot=1;

/**************************** no configuration below  here ***********************/

//pretty print_r
function print_r_tree($data)
{
    // capture the output of print_r
    $out = print_r($data, true);

    // replace something like '[element] => <newline> (' with <a href="javascript:toggleDisplay('...');">...</a><div id="..." style="display: none;">
    $out = preg_replace('/([ \t]*)(\[[^\]]+\][ \t]*\=\>[ \t]*[a-z0-9 \t_]+)\n[ \t]*\(/iUe',"'\\1<a href=\"javascript:toggleDisplay(\''.(\$id = substr(md5(rand().'\\0'), 0, 7)).'\');\">\\2</a><div id=\"'.\$id.'\" style=\"display: none;\">'", $out);

    // replace ')' on its own on a new line (surrounded by whitespace is ok) with '</div>
    $out = preg_replace('/^\s*\)\s*$/m', '</div>', $out);

    // print the javascript function toggleDisplay() and then the transformed output
    //echo '<pre><script language="Javascript">function toggleDisplay(id) { document.getElementById(id).style.display = (document.getElementById(id).style.display == "block") ? "none" : "block"; }</script>'."\n$out</pre>";
    echo "<pre>$out</pre>";
}

function ip2fqdn($ip) {

  $cmd="host -W 1 $ip|awk '{print $NF}'";
  if ( ($pfp = popen($cmd, 'r')) === false ) 
    die("calling \"$cmd\" failed: ${php_errormsg}\n"); 
  $host = trim(fgets($pfp, 1024)); 

  return $host;

}

//returns brand manufacturer from mac address
function brandofmac($mac) {
  $mac=strtoupper($mac);
  $mac=str_replace(':',"-",$mac);
  $mac=str_replace(' ',"-",$mac);
  $macx=explode("-",$mac);
  $qmac="{$macx[0]}-{$macx[1]}-{$macx[2]}";
  $grepmac=$macx[0].$macx[1].$macx[2];
  $cmd="curl -sd 'x=$qmac' http://standards.ieee.org/cgi-bin/ouisearch|grep $grepmac|sed 's/.*base[^)]*)//'";
  if ( ($pfp = popen($cmd, 'r')) === false ) 
    die("calling \"$cmd\" failed: ${php_errormsg}\n"); 
  $brand = trim(fgets($pfp, 4096)); 


  return $brand;
}


/* snmpwalk */
function sw($host, $oid, $community="public") {

  if (!strlen($oid)) {
    echo "sw: called with null OID\n";exit;
  }
  if ($host=="0.0.0.0") {
    $data[0]="";
    return $data;
  }


  //return snmpwalk($host, $community, $object_id,3000); //php's own snmpwalk
  /* call snmpwalk merging multiline strings */
  $cmd="snmpwalk -t 1 -r 0 -On -v 1 -c $community  $host $oid|".
       'tr \'\r\n\' \'  \'|sed -e \'s/\([.]\+1\.3\.6\)/\n\1/g\' -e \'s/$/\n/\'';

  //echo "CMD=$cmd\n";
  if ( ($pfp = popen($cmd, 'r')) === false ) 
    die("calling \"$cmd\" failed: ${php_errormsg}\n"); 

  /* return lines in an array, one element per line */
  for ($i=0;!feof($pfp);$i++) {
    $x = trim(fgets($pfp, 4096)); 
    if (strlen($x)>1) 
      $data[$i] = chop($x);
    else $i--;
  }
  pclose($pfp);
  return $data;

}

//read snmp response lines and return only the value part
function snmpstrings($str) {
  for ($i=0;$i<count($str);$i++) {
    $x=explode(':',$str[$i],2); $x=$x[1];
    $str[$i]=$x;
  }
  return $str;
}

//query some CDP information from $host
function getcdp($host) {
  if (($host=="0.0.0.0") || $host=="") { 
    $data['cdpaddress']="0.0.0.0";
    $data['cdpdeviceid']="0.0.0.0";
    $data['cdpdeviceport']="0.0.0.0";
    $data['cdpplatform']="0.0.0.0";
    return $data; 
  }

  $cdpCacheAddress=sw($host,"1.3.6.1.4.1.9.9.23.1.2.1.1.4");//cdpCacheAddress
  for ($i=0;$i<count($cdpCacheAddress);$i++) {
    $x=explode(":",$cdpCacheAddress[$i]);
    $xx=sscanf($x[1],"%x %x %x %x");
    $ip=implode(".",$xx);
    $cdpCacheAddress[$i]=$ip;
  }

  $cdpCacheDeviceId =sw($host,"1.3.6.1.4.1.9.9.23.1.2.1.1.6");
  $cdpCacheDevicePort =sw($host,"1.3.6.1.4.1.9.9.23.1.2.1.1.7");
  $cdpCachePlatform =sw($host,"1.3.6.1.4.1.9.9.23.1.2.1.1.8");

  $entPhysicalDescr_oid="1.3.6.1.2.1.47.1.1.1.1.2.1";
  $entPhysicalDescr =sw($host,"$entPhysicalDescr_oid");
  $data['physdescr']=snmpstrings($entPhysicalDescr);

  $data['cdpaddress']=$cdpCacheAddress;
  $data['cdpdeviceid']=snmpstrings($cdpCacheDeviceId);
  $data['cdpdeviceport']=snmpstrings($cdpCacheDevicePort);
  $data['cdpplatform']=snmpstrings($cdpCachePlatform);

  $data['cdplocalifindex']= snmp2array($cdpCacheDeviceId,$cdpCacheDeviceId,0,0,1);
  return $data;
}

//call getcdp recursively 
function getcdp_rec($host) {
  static $depth=0;
  global $data;

  $depth++;
  if ($depth==10) {
    echo "\nToo much depth in CDP recursion\n";
    exit;
  }
  $data[$host]=getcdp($host);
  for ($i=0;$i<count($data[$host]['cdpaddress']);$i++) {
    $addr=$data[$host]['cdpaddress'][$i];
    if ($host=="0.0.0.0")  //no ip management there
      continue;
    if (!strlen($addr)) 
      continue;
    if (array_key_exists($addr,$data)) 
      continue; //if already got cdp info for this ip (links are bidirectional)
    getcdp_rec($addr);
  }
  $depth--;
  if ($depth==0) 
    return $data;
}


//cdp

/* find out host connectivity */
$data=getcdp_rec($starthost);

function getlastpart($delimiter,$string) {
  $x=explode($delimiter,$string);
  return $x[count($x)-1];
}

/* We now have a list of hosts and their connectivity */

//convert snmp data to table where keys correspond to snmp oid
//onlylast: return only last part of extra oid
function snmp2array ($lines,$oid,$onlylast=0,$skipkeys=0,$rcropkey=0) {
  for ($i=0;$i<count($lines);$i++) {
    $linearr=explode("=",$lines[$i]);
    $linearr[0]=trim($linearr[0]);
    //oid2:extra oid stuff appended to request oid. Used as key
    $oid2=substr($linearr[0],strpos($linearr[0],$oid)+strlen($oid)+1);
    for ($sk=0;$sk<$skipkeys;$sk++) {
      $oid2=substr($oid2,strpos($oid2,".")+1);
    }
    if ($onlylast) 
      $oid2=getlastpart(".",$oid2);

    if ($rcropkey) {
      $oidx=explode(".",$oid2);
      $x=$oidx[count($oidx)-$rcropkey-1];
      $arr[$i]=$x;
    }
    else
    {
      $x=explode(":",$linearr[1],2);
      $arr[$oid2]=trim($x[1]);
    }
  }
  return $arr;
}

/*read local arp entries*/
function getlocalarp() {
  global $ip2maclocal,$mac2iplocal;
  global $starthost;

  /* populate local arp table */
  /* you may need to modify this command */
  $cmd="nmap -n --host-timeout 2000 -sP $starthost/24";
  if ( ($pfp = popen($cmd, 'r')) === false ) 
    die("calling \"$cmd\" failed: ${php_errormsg}\n"); 
  while (!feof($pfp)) fgets($pfp, 4096); 
  pclose($pfp);

  /* read arp table*/
  $cmd="arp -ne|fgrep ether|awk '{print $1,$3}'";
  if ( ($pfp = popen($cmd, 'r')) === false ) 
    die("calling \"$cmd\" failed: ${php_errormsg}\n"); 
  while (!feof($pfp)) {
    $l=explode(" ",trim(fgets($pfp, 4096))); 
    if (!strlen($l[0])) continue;
    $ip2maclocal[$l[0]]=$l[1];
    $mac2iplocal[$l[1]]=$l[0];
  }
  pclose($pfp);

}

/* read ipNetToMediaPhysAddress from router */
$ipNetToMediaPhysAddress_oid="1.3.6.1.2.1.4.22.1.2";
$ipNetToMediaPhysAddress=sw($starthost,$ipNetToMediaPhysAddress_oid);
$ip2mac= snmp2array($ipNetToMediaPhysAddress,$ipNetToMediaPhysAddress_oid,0,1);

foreach ($ip2mac as $ip=>&$mac) { 
  $mac=str_replace(':'," ",$mac);
  $m=explode(" ",$mac);
  for ($mac2="",$x=0;$x<count($m);$x++) 
    $mac2.=sprintf("%02X ",hexdec($m[$x]));
  $mac=strtoupper(trim($mac2));
  if (is_array($mac2ips[$mac]))
    array_push($mac2ips[$mac],$ip);
  else
    $mac2ips[$mac][0]=$ip;
}



/* get more host information and vlans */
foreach ($data as $hostip=>$hostdata) { /* foreach host */
  //if ($hostip=="0.0.0.0") continue;
  //print_r($hostdata);echo "----$hostip-------\n";

  /* get portnames */
  $ifindex2portname_oid="1.3.6.1.2.1.31.1.1.1.1";
  $ifindex2portname=sw($hostip,$ifindex2portname_oid);


  $vtpVlanState_oid="1.3.6.1.4.1.9.9.46.1.3.1.1.2";
  $vtpVlanState=sw($hostip,$vtpVlanState_oid);

  $vtpVlanName_oid="1.3.6.1.4.1.9.9.46.1.3.1.1.4";
  $vtpVlanName=sw($hostip,$vtpVlanName_oid);

  //ifindex2vlan
  $vmVlan_oid="1.3.6.1.4.1.9.9.68.1.2.2.1.2";
  $vmVlan=sw($hostip,$vmVlan_oid);

  //system description
  $sysDescr =sw($hostip,".1.3.6.1.2.1.1.1.0");
  $sysServices =sw($hostip,".1.3.6.1.2.1.1.7.0");

  $data[$hostip]['ifindex2portname']= snmp2array($ifindex2portname,$ifindex2portname_oid);
  $data[$hostip]['vtpvlanstate']= snmp2array($vtpVlanState,$vtpVlanState_oid,1);
  $data[$hostip]['vtpvlanname']= snmp2array($vtpVlanName,$vtpVlanName_oid,1);
  $data[$hostip]['ifindex2vlan']= snmp2array($vmVlan,$vmVlan_oid,0);
  $data[$hostip]['sysdescr']=snmpstrings($sysDescr);
  $data[$hostip]['sysservices']=snmpstrings($sysServices);


  /* for each vlan get macs, mac2bridgeport, bridgeport2ifindex*/
  if ($data[$hostip]['sysservices'][0]<78) { //not a router
    foreach ($data[$hostip]['vtpvlanstate'] as $vlanid=>$state) { //foreach vlan

      if ($vlanid>1000) continue; //internal cisco vlans

      $dot1dTpFdbAddress_oid="1.3.6.1.2.1.17.4.3.1.1";
      $dot1dTpFdbAddress=sw($hostip,$dot1dTpFdbAddress_oid,"public@$vlanid");
      $data[$hostip]['macs']= snmp2array($dot1dTpFdbAddress,$dot1dTpFdbAddress_oid);

      $dot1dTpFdbPort_oid="1.3.6.1.2.1.17.4.3.1.2";
      $dot1dTpFdbPort=sw($hostip,$dot1dTpFdbPort_oid,"public@$vlanid");
      $data[$hostip]['mac2bridgeport']= snmp2array($dot1dTpFdbPort,$dot1dTpFdbPort_oid);

      $dot1dBasePortIfIndex_oid="1.3.6.1.2.1.17.1.4.1.2";
      $dot1dBasePortIfIndex=sw($hostip,$dot1dBasePortIfIndex_oid,"public@$vlanid");
      $data[$hostip]['bridgeport2ifindex']= snmp2array($dot1dBasePortIfIndex,$dot1dBasePortIfIndex_oid,1);

    } //foreach vlan

    /* create the mac2portname entry in cdp from gathered info*/
    foreach ($data[$hostip]['macs'] as $decmac=>$hexmac) { //foreach mac
      $bridgeport=$data[$hostip]['mac2bridgeport'][$decmac];
      $ifindex=$data[$hostip]['bridgeport2ifindex'][$bridgeport];
      $vlan=$data[$hostip]['ifindex2vlan'][$ifindex];
      $portname=$data[$hostip]['ifindex2portname'][$ifindex];
      $data[$hostip]['mac2portname'][$hexmac]=$portname;
      $data[$hostip]['mac2vlan'][$hexmac]=$vlan;

      //an ifindex can have lots of macs
      if (is_array($data[$hostip]['ifindex2mac'][$ifindex]))
	array_push($data[$hostip]['ifindex2mac'][$ifindex],$hexmac);
      else
	$data[$hostip]['ifindex2mac'][$ifindex][0]=$hexmac;

    }//foreach mac
  }//if not router
} //foreach host


/*
//relate remote cdp ip with local ifindex (through mac->ips, ifindex->macs)
foreach ($data as $hostip=>$hostdata) { 
  for ($i=0;$i<count($data[$hostip]['cdpaddress']);$i++) { //foreach remote ip gathered by cdp
    $addr=$data[$hostip]['cdpaddress'][$i]; //cdp address
    if (($addr=="0.0.0.0")||($hostip=="0.0.0.0"))  
      continue;
    //find our ifindex which goes to this ip (from mac address table->ip)
    $mac=$ip2mac[$addr]; //mac of cdp address
    if (array_key_exists('ifindex2mac',$data[$hostip])) 
      foreach ($data[$hostip]['ifindex2mac'] as $ifindex=>$macarr) { 
	if (false !== array_search($mac,$macarr)) {
	  $data[$hostip]['cdplocalifindex'][$i]=$ifindex;
	}
      }
  }
}
*/


/**********************************************/
/* We've got all we could. Now create the graphs */

$headstr="digraph structs {\nnode [shape=Mrecord];\n";

//iterate hosts
$hoststr="";
foreach ($data as $hostip=>$hostdata) { /* foreach host */
  $sysservices=(int)$data[$hostip]['sysservices'][0];
  $physdescr=$data[$hostip]['physdescr'][0];
  $physdescr=str_replace('"',"'",$physdescr);
  $physdescr=str_replace(',',"\\n",$physdescr);
  $physdescr=str_replace('\\n ',"\\n",$physdescr);
  //$physdescr=preg_replace("/\W/","\n",$physdescr);

  if ($sysservices==78) {$hosttype="router";$color="lightpink";}
  elseif (($sysservices>0) && ($sysservices<10)) {$hosttype="switch"; $color="lightblue";}
  else {$hosttype="otherhost";$color="grey";}

  $hostip2=str_replace('.',"_",trim($hostip));
  //$hoststr.= "host_$hostip2 [fontsize=10 color=$color label=\"{".' '.$hostip.'_'.$physdescr.'| ';
  //$hoststr.= "\"host_$hostip2\" [fontsize=10 color=$color label=\"{".' '.$hostip.'\n'.$physdescr.'| {';
  $hoststr.= "\"host_$hostip2\" [fontsize=10 color=$color label=\"{".' '.$hostip.'\n'.$physdescr.'| ';

  $count=0;
  if (array_key_exists('ifindex2portname',$data[$hostip])) 
    foreach ($data[$hostip]['ifindex2portname'] as $ifindex=>$portname) { //interface
      $portname=str_replace('"',"",$portname);
      if (array_key_exists('ifindex2vlan',$data[$hostip]))
	$vlan=$data[$hostip]['ifindex2vlan'][$ifindex];
      else $vlan="";
      //connect to: macs, ips of macs
      if (strlen($vlan)) $vlan2="(VLAN$vlan)"; else $vlan2="";
      //print struct port
      $hoststr.= "<$ifindex> $portname $vlan2";
      /*
      if ($count & 1) // odd port
	$hoststr.= "}|{";
      else
	$hoststr.= "|";
	*/
	$hoststr.="|";
      $count++;
    }
  /*
  if ($hoststr[strlen($hoststr)-1]=="|")
    $hoststr.="}"; //remove trailing "|" 
  elseif ($hoststr[strlen($hoststr)-1]=="{")
    $hoststr=substr($hoststr,0,-2); //remove trailing "|{" 
    */
    $hoststr=substr($hoststr,0,-1); //remove trailing "|" 
  $hoststr.=" }\"];\n\n";
}




$hoststr2="";
//now print other host nodes
foreach ($mac2ips as $mac=>$iparr) { 
  //find if we already printed this mac's ip
  $iplist="";
  for ($cont=0,$i=0;$i<count($iparr);$i++) { //iterate ips of mac
    $ip=$iparr[$i];
    if (array_key_exists($ip,$data)) {
      $cont++; //ip belongs to a top-node (found from cdp)
    }
    $iplist.="$ip ";
  }
  if ($cont) 
    continue;

  $mac2=str_replace(' ',"_",trim($mac));
  $mac3=str_replace(' ',":",trim($mac));
  $iplist=str_replace(' ',"\n",trim($iplist));

  $brand="";
  if ($wantbrand) 
    $brand=brandofmac($mac); //find manufacturer names from MACs
  $brand=str_replace(' ',"_",trim($brand));
  $brand=str_replace('.',"",$brand);
  $brand=str_replace(',_',"_",$brand);
  if (strlen($brand)) $brand='\n'.$brand;
  $hoststr2.= "\"host_$mac2\" [fontsize=10 label=\"<$mac2> $mac3\\n$iplist$brand\"];\n";
}





/*now define node connections*/
$connstr="";
foreach ($data as $hostip=>$hostdata) { /* foreach host */
  $cdpedges="";
  $macstr="";

  if ($hostip=="0.0.0.0") continue;
  $hostip2=str_replace('.',"_",trim($hostip));

  if (array_key_exists('cdpaddress',$data[$hostip])) 
    foreach ($data[$hostip]['cdpaddress'] as $i=>$cdpaddress) { 
      //$cdpdeviceid=$data[$hostip]['cdpdeviceid'][$i];
      $cdpdeviceport=$data[$hostip]['cdpdeviceport'][$i];
      $cdpdeviceport=trim(str_replace('"',"",$cdpdeviceport));
      $cdpaddress2=str_replace('.',"_",trim($cdpaddress));
      $cdplocalifindex=$data[$hostip]['cdplocalifindex'][$i];
      $cdpedges.= "\"host_$hostip2\":$cdplocalifindex -> \"host_$cdpaddress2\" [fontsize=9 color=red style=dashed label=\"Goes to $cdpaddress\\n on port:($cdpdeviceport)\"];\n";
    }

  //iterate interface -> mac address table
  if (array_key_exists('ifindex2mac',$data[$hostip]))
    foreach($data[$hostip]['ifindex2mac'] as $ifindex=>$macarray) { //multiple macs per interface
      $macstr1="";
      if (in_array($ifindex,$data[$hostip]['cdplocalifindex'])) { //port connecting switches
	continue;
      }

      //if multiple macs on a port, make the links only if target is not another known switch
      for ($e=0,$i=0;$i<count($macarray);$i++) { //iterate macs of interface
	$mac=$macarray[$i];
	$mac2=str_replace(' ',"_",trim($mac));
	$h=(float)mt_rand( 0  , 100  )/100.0; //for hsv
	$macstr1.= "\"host_$hostip2\":$ifindex -> \"host_$mac2\" [color=\"$h 1.000 1.000\"];\n";
      }//macs

      $macstr.= $macstr1;

    }//foreach

  $connstr.=$cdpedges;
  $connstr.=$macstr;
  #echo $cdpedges;
  #echo $macstr;
}

$tailstr= "}\n";


if ($wantdot) {
  echo "<br>Calling dot...<br>\n";
  if(($fp = fopen("x.dot",'w')) === FALSE)
    die("Failed to open x.dot for writing:$php_errormsg!");
  fwrite($fp,$headstr);
  fwrite($fp,$hoststr);
  fwrite($fp,$hoststr2);
  fwrite($fp,$connstr);
  fwrite($fp,$tailstr);
  fclose($fp);
  $cmd="dot x.dot -Tpng>x.png";
  if ( ($pfp = popen($cmd, 'r')) === false ) 
    die("calling \"$cmd\" failed: ${php_errormsg}\n"); 
  $x=trim(fgets($pfp,1024));
  if (strlen($x)) 
    echo "\nDot reports: $x\n";

}

if ($wantlocalarp){
  echo "<br>Updating local arp table ...<br>\n";
  getlocalarp();
}

print_r_tree($data);
$data2['ip2mac']=$ip2mac;
$data2['mac2ips']=$mac2ips;

if ($wantlocalarp) {
  $data2['ip2maclocal']=$ip2maclocal;
  $data2['mac2iplocal']=$mac2iplocal;
}
print_r_tree($data2);

if ($wantdot) {
  echo "\n<a href='x.png'><img src='x.png' width=500></a><br>";

}


?>
</body>
</html>
